import * as React from 'react';
import { StyleProp, ViewStyle } from 'react-native';
import { Props as TabBarProps } from './TabBar';
import { Layout, NavigationState, Route, SceneRendererProps, PagerProps } from './types';
export declare type Props<T extends Route> = PagerProps & {
    onIndexChange: (index: number) => void;
    navigationState: NavigationState<T>;
    renderScene: (props: SceneRendererProps & {
        route: T;
    }) => React.ReactNode;
    renderLazyPlaceholder: (props: {
        route: T;
    }) => React.ReactNode;
    renderTabBar: (props: SceneRendererProps & {
        navigationState: NavigationState<T>;
    }) => React.ReactNode;
    tabBarPosition: 'top' | 'bottom';
    initialLayout?: {
        width?: number;
        height?: number;
    };
    lazy: ((props: {
        route: T;
    }) => boolean) | boolean;
    lazyPreloadDistance: number;
    sceneContainerStyle?: StyleProp<ViewStyle>;
    style?: StyleProp<ViewStyle>;
};
declare type State = {
    layout: Layout;
};
export default class TabView<T extends Route> extends React.Component<Props<T>, State> {
    static defaultProps: {
        tabBarPosition: string;
        renderTabBar: <P extends Route>(props: TabBarProps<P>) => JSX.Element;
        renderLazyPlaceholder: () => null;
        keyboardDismissMode: string;
        swipeEnabled: boolean;
        lazy: boolean;
        lazyPreloadDistance: number;
        removeClippedSubviews: boolean;
    };
    state: {
        layout: {
            width: number;
            height: number;
        };
    };
    private jumpToIndex;
    private handleLayout;
    render(): JSX.Element;
}
export {};
